/*****************************************************************/
/*  Program umoliwia wystawienie oceny na podstawie liczby      */
/*  uzyskanych punktw wedug nastpujcego kryterium:           */
/* 	 0 -  49 pkt.	2                                        */
/*	50 -  59 pkt.	3				       	 */
/*	60 -  69 pkt.	3+					 */
/*	70 -  79 pkt.	4					 */
/*	80 -  89 pkt.	4+					 */
/*	90 - 100 pkt.	5					 */
/*  UWAGA: nazwiska i punkty s przechowywane w tablicy struktur */
/*****************************************************************/
#include <iostream.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>
#include <fstream.h>

const int Max_Punkt = 100,
	  Min_Punkt = 0,
	  n         = 20;
char Napis [] = {"Ile osb oceniasz?: "};
enum Stopnie {ndst, dst, dst_plus, db, db_plus, bdb};
struct Osoba
  { char Nazwisko[30];
    int Punkty;
  };
Osoba Dane[n];
int Ile_Osob;
void Pisz_Naglowek (char Napis1[], char Napis2[], char Napis3[]);
int Czyt_Int ( char Napisy[], int Ogr_d, int Ogr_g);
void Wprowadz_Jedna_Osobe(char Nazwisko[], int &Lp, int Ogr_d, int Ogr_g);
void Wprowadz_Wszystkie_Dane(Osoba Dane[],
			      int Ile_Osob, int Ogr_d, int Ogr_g);
Stopnie Wystaw_Ocene ( int Lp );
void Wyswietl_Ocene ( Stopnie Ocena);
void Wyswietl_Wszystkie_Oceny(Osoba Dane[],int Ile_Osob);
/*----------------------------------------------------------------*/

void main ()		// program gwny
{
  clrscr ();
  Ile_Osob = Czyt_Int(Napis, 1,n);
  Pisz_Naglowek("Nazwisko", "Liczba punktw", "");
  Wprowadz_Wszystkie_Dane(Dane, Ile_Osob, Min_Punkt, Max_Punkt);
  Pisz_Naglowek("Nazwisko", "Liczba punktw", "Ocena");
  Wyswietl_Wszystkie_Oceny(Dane, Ile_Osob);
  while (!kbhit())
  { }
}			// koniec programu gwnego

/*----------------------------------------------------------------*/

void Pisz_Naglowek (char Napis1[], char Napis2[], char Napis3[])
/*  Procedura umozliwia napisanie nagwka skadajacego si  */
/*  z max trzech wyrazw                                     */
{
  clrscr();
  cout << Napis1;
  gotoxy (32, wherey());
  cout << Napis2;
  gotoxy (55, wherey());
  cout << Napis3 << endl;
  cout << endl;
}

int Czyt_Int ( char Napisy[], int Ogr_d, int Ogr_g)
/* Funkcja umoliwia wczytanie liczby cakowitej oraz	   */
/* kontrolowanie formalnej i logicznej poprawnoci liczby  */

{
  int x, y, Liczba, r;
  enum Boolean {false, true} Poza_Zakresem, Powtorz;
    cout << Napisy;
    x = wherex();
    y = wherey();
     while (1)
       {
	   cin >> Liczba;
	   Powtorz = (Liczba < Ogr_d) || (Liczba > Ogr_g) || (cin.fail());
	   if (cin.fail())
	     {
		cin.clear(cin.rdstate() & ~ios::failbit);
		char L[80];
		cin >> L;
	     }
	   if (Powtorz)
	     {
	       gotoxy (x, y);
	       clreol ();
	      }
	   else break;
	}
    return Liczba;
}
/*----------------------------------------------------------------*/

void Wprowadz_Jedna_Osobe(char Nazwisko[], int &Lp, int Ogr_d, int Ogr_g)
/* Procedura umozliwia wprowadzenie nazwiska i liczby punktw */
/* dla jednej osoby.					      */
/* UWAGA: po wprowadzeniu nazwiska nacisn <Enter>,          */
/*        wprowadzi liczb punktw i nacisn <Enter>.       */

{
  cin >> Nazwisko;
  gotoxy(32, wherey()-1);
  Lp = Czyt_Int("", Ogr_d, Ogr_g);
}


void Wprowadz_Wszystkie_Dane(Osoba Dane[],
			     int Ile_Osob, int Ogr_d, int Ogr_g)
/*  Procedura umozliwia wprowadzenie nazwisk i punktw */
/*  dla caej grupy				       */

{
  int i;
    for (i=0; i < Ile_Osob; i++)
      Wprowadz_Jedna_Osobe(Dane[i].Nazwisko, Dane[i].Punkty, Ogr_d, Ogr_g);
}



Stopnie Wystaw_Ocene ( int Lp )
/* Funkcja umoliwia wystawienie oceny na podstawie  */
/* liczby uzyskanych punktw.                        */

{
  Stopnie Wynik;
    Lp = Lp/10;
    switch (Lp)
      {
	 default : { Wynik = ndst; break; }
	  case 5 : { Wynik = dst; break; }
	  case 6 : { Wynik = dst_plus; break; }
	  case 7 : { Wynik = db; break; }
	  case 8 : { Wynik = db_plus; break; }
	  case 9 : { Wynik = bdb; break; }
	 case 10 : { Wynik = bdb; break; }
     }
    return Wynik;
}
/*----------------------------------------------------------------*/

void Wyswietl_Ocene ( Stopnie Ocena)
/* Funkcja umoliwia wywietlenie oceny w postaci sownej */

{
  switch (Ocena)
  {
    case ndst     : { cout << "niedostateczna\n"; break; }
    case dst      : { cout << "dostateczna\n"; break; }
    case dst_plus : { cout << "do dobra\n"; break; }
    case db       : { cout << "dobra\n"; break; }
    case db_plus  : { cout << "ponad dobra\n"; break; }
    case bdb      : { cout << "bardzo dobra\n"; break; }
  }
}

void Wyswietl_Wszystkie_Oceny(Osoba Dane[], int Ile_Osob)
/*  Procedura umoliwia wywietlenie oceny w postaci sownej */
/*  dla wszystkich osb.				     */
{
 int i;
 Stopnie Ocena;
 for (i=0; i < Ile_Osob; i++)
   {
    Ocena = Wystaw_Ocene(Dane[i].Punkty);
    cout << Dane[i].Nazwisko;
    gotoxy(32, wherey ());
    cout << Dane[i].Punkty;
    gotoxy (55, wherey ());
    Wyswietl_Ocene(Ocena);
   }
}
